package com.alibaba.fastsql.interpreter.expr;

import com.alibaba.fastsql.interpreter.InterpreterContext;

public class DivideLong extends LongArithmeticBinaryExpr implements Expr<Long> {
    private Expr<Long> left;
    private Expr<Long> right;

    public DivideLong(Expr<Long> left, Expr<Long> right) {
        super (ArithmeticBinaryOperator.DIVIDE);

        this.left = left;
        this.right = right;
    }

    @Override
    public Long eval(InterpreterContext context) {
        Long leftVal = left.eval(context);
        if (leftVal == null) {
            return null;
        }

        Long rightVal = right.eval(context);
        if (rightVal == null) {
            return null;
        }

        return leftVal / rightVal;
    }
}
