package com.alibaba.fastsql.interpreter.expr;

import com.alibaba.fastsql.interpreter.InterpreterContext;

import java.math.BigDecimal;

public class FieldLong extends LongExpr implements Expr<Long> {
    private final String field;

    public FieldLong(String field) {
        this.field = field;
    }

    @Override
    public Long eval(InterpreterContext context) {
        Object fieldValue = context.getFieldValue(field);
        if (fieldValue instanceof Long) {
            return (Long) fieldValue;
        } else if (fieldValue instanceof BigDecimal) {
            return ((BigDecimal) fieldValue).longValueExact();
        } else if (fieldValue instanceof Number) {
            return ((Number) fieldValue).longValue();
        }

        return null;
    }
}
