package com.alibaba.fastsql.interpreter.expr;

import com.alibaba.fastsql.interpreter.InterpreterContext;

public class GELong extends BooleanExpr implements Expr<Boolean> {
    private Expr<Long> left;
    private Expr<Long> right;

    public GELong(Expr<Long> left, Expr<Long> right) {
        this.left = left;
        this.right = right;
    }

    @Override
    public Boolean eval(InterpreterContext context) {
        Long leftValue = left.eval(context);
        if (leftValue == null) {
            return null;
        }

        Long rightValue = right.eval(context);
        if (rightValue == null) {
            return null;
        }

        return leftValue.longValue() >= rightValue.longValue();
    }
}
