package com.alibaba.fastsql.interpreter.expr;

import com.alibaba.fastsql.interpreter.InterpreterContext;

public class IFLong extends LongExpr implements Expr<Long> {
    private final Expr<Boolean> test;
    private final Expr<Long> trureValue;
    private final Expr<Long> falseValue;

    public IFLong(Expr<Boolean> test, Expr<Long> trureValue, Expr<Long> falseValue) {
        this.test = test;
        this.trureValue = trureValue;
        this.falseValue = falseValue;
    }

    @Override
    public Long eval(InterpreterContext context) {
        Boolean testValue = test.eval(context);
        if (testValue == null) {
            return null;
        }

        if (testValue.booleanValue()) {
            return trureValue.eval(context);
        } else {
            return falseValue.eval(context);
        }
    }
}
