package com.alibaba.fastsql.interpreter.expr;

import com.alibaba.fastsql.interpreter.InterpreterContext;

import java.util.List;

public class MaxLong extends LongFunction {

    public MaxLong(Expr<Long>... arguments) {
        super(arguments);
    }

    @Override
    public Long eval(InterpreterContext context) {
        Long max = null;
        for (Expr<Long> arg : arguments) {
            Long param = arg.eval(context);
            if (max == null) {
                max = param;
            } else {
                if (param != null && param.longValue() > max.longValue()) {
                    max = param;
                }
            }
        }
        return max;
    }
}
