package com.alibaba.fastsql.interpreter.expr;

import com.alibaba.fastsql.interpreter.InterpreterContext;

import java.util.List;

public class MinLong extends LongFunction {

    public MinLong(Expr<Long>... arguments) {
        super(arguments);
    }

    @Override
    public Long eval(InterpreterContext context) {
        Long min = null;
        for (Expr<Long> arg : arguments) {
            Long param = arg.eval(context);
            if (min == null) {
                min = param;
            } else {
                if (param != null && param.longValue() < min.longValue()) {
                    min = param;
                }
            }
        }
        return min;
    }
}
