package com.alibaba.fastsql.sql.optimizer;

import com.alibaba.fastjson.serializer.SerializerFeature;

public enum  OptimizerFeature {
    ConstFolding(0),
    PushUp(1),
    PushDown(2),
    MergeUnion(3),
    Ordinal(4),

    CastFloatToReal(5), // for aliyun ads

    PipesAsConcat(6),

    TypeInference(7),

    ADSRewrite(8),
    PushDownCount(9),

    ImplicitJoinRewrite(10),
    DistinctEagerAggregation(11),
    ViewRewriteWithSchema(12),
    ViewRewrite(13),
    DecorticateExistsWithAGG(14),

    ClearSelectHint(15),
    MultiDistinctEagerAggregation(16),
    NoLimitMerged(17),

    BackQuotedNames(18)
    ;

    public final long mask;

    OptimizerFeature(int ordinal){
        mask = (1 << ordinal);
    }

    public static int of(OptimizerFeature[] features) {
        if (features == null) {
            return 0;
        }

        int value = 0;

        for (OptimizerFeature feature: features) {
            value |= feature.mask;
        }

        return value;
    }

    public static boolean isEnabled(long features, OptimizerFeature feature) {
        return (features & feature.mask) != 0;
    }
}
