package com.alibaba.fastsql.sql.optimizer.rules;

import com.alibaba.fastsql.sql.SQLUtils;
import com.alibaba.fastsql.sql.ast.SQLExpr;
import com.alibaba.fastsql.sql.ast.expr.SQLBinaryOpExpr;
import com.alibaba.fastsql.sql.ast.expr.SQLBinaryOperator;
import com.alibaba.fastsql.sql.ast.expr.SQLMethodInvokeExpr;

import java.util.List;

public class PipesAsConcat extends OptimizerVisitor {
    public boolean visit(SQLBinaryOpExpr x) {
        if (isGroup(x)) {
            return super.visit(x);
        }

        if (x.getOperator() == SQLBinaryOperator.Concat) {
            SQLMethodInvokeExpr concat = new SQLMethodInvokeExpr("CONCAT");

            List<SQLExpr> items = SQLBinaryOpExpr.split(x);
            for (SQLExpr item : items) {
                concat.addParameter(item);
            }

            if (SQLUtils.replaceInParent(x, concat)) {
                optimizedCount++;
                concat.accept(this);
                return false;
            }
        }

        return true;
    }
}
