package com.alibaba.fastsql.sql.optimizer.rules;

import com.alibaba.fastsql.sql.SQLUtils;
import com.alibaba.fastsql.sql.ast.SQLExpr;
import com.alibaba.fastsql.sql.ast.SQLName;
import com.alibaba.fastsql.sql.ast.expr.SQLAllColumnExpr;
import com.alibaba.fastsql.sql.ast.expr.SQLIdentifierExpr;
import com.alibaba.fastsql.sql.ast.expr.SQLPropertyExpr;
import com.alibaba.fastsql.sql.ast.statement.*;
import com.alibaba.fastsql.sql.repository.Schema;
import com.alibaba.fastsql.sql.repository.SchemaObject;
import com.alibaba.fastsql.sql.repository.SchemaRepository;
import com.alibaba.fastsql.sql.visitor.SQLASTVisitorAdapter;
import com.alibaba.fastsql.util.FnvHash;
import com.alibaba.fastsql.util.StringUtils;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import static com.alibaba.fastsql.util.StringUtils.quoteAlias;

/**
 * @author lijun.cailj 2018/9/7
 */
public class ViewRewriteRefAlias extends OptimizerVisitor {

    private Map<String, String> originalViewMap = new HashMap<String, String>();

    public ViewRewriteRefAlias(Map<String, String> originalViewMap) {
        this.originalViewMap = originalViewMap;
    }

    @Override
    public boolean visit(SQLPropertyExpr x) {
        SQLExpr owner = ((SQLPropertyExpr) x).getOwner();
        if(owner instanceof SQLIdentifierExpr) {
            String newViewName = originalViewMap.get(SQLUtils.normalize(owner.toString().toLowerCase()));
            if (!StringUtils.isEmpty(newViewName)) {
                ((SQLPropertyExpr) x).setOwner(newViewName);
            }
        } else if (owner instanceof SQLPropertyExpr) {
            String oldViewName = SQLUtils.normalize(((SQLPropertyExpr) owner).getSimpleName());
            String newViewName = originalViewMap.get(SQLUtils.normalize(oldViewName));
            if (!StringUtils.isEmpty(newViewName)) {
                ((SQLPropertyExpr) x).setOwner(new SQLPropertyExpr(((SQLPropertyExpr) owner).getOwnernName(), newViewName));
            }
        }
        return false;
    }

}
